--- nagios-cvs/include/objects_org.h	2006-02-14 16:50:30.000000000 +0100
+++ nagios-cvs/include/objects.h	2006-02-14 16:51:02.000000000 +0100
@@ -201,6 +201,7 @@ typedef struct host_struct{
 	double  percent_state_change;
 	int     total_services;
 	unsigned long total_service_check_interval;
+	unsigned long avg_service_check_interval;
 	unsigned long modified_attributes;
 	int     circular_path_checked;
 	int     contains_circular_path;
--- nagios-cvs/base/flapping_org.c	2006-02-14 16:49:39.000000000 +0100
+++ nagios-cvs/base/flapping.c	2006-02-14 16:52:05.000000000 +0100
@@ -175,7 +175,7 @@ void check_for_host_flapping(host *hst, 
 		wait_threshold=hst->notification_interval*interval_length;
 	
 	else
-		wait_threshold=(hst->total_service_check_interval*interval_length)/hst->total_services;
+		wait_threshold=hst->avg_service_check_interval*interval_length;
 
 	/* if we haven't waited long enough since last record, only update if we've had a state change */
 	if((current_time-hst->last_state_history_update)<wait_threshold){
--- nagios-cvs/base/config_org.c	2006-02-14 16:52:21.000000000 +0100
+++ nagios-cvs/base/config.c	2006-02-14 17:02:10.000000000 +0100
@@ -1636,7 +1636,7 @@ int pre_flight_check(void){
 	int total_objects=0;
 	int warnings=0;
 	int errors=0;
-
+	unsigned long avg_interval_counter=0;
 #ifdef DEBUG0
 	printf("pre_flight_check() start\n");
 #endif
@@ -2812,7 +2812,18 @@ int pre_flight_check(void){
 			temp_host->total_service_check_interval+=temp_service->check_interval;
 		        }
 	        }
-
+	/* calculate average service check interval */
+	for(temp_service=service_list;temp_service!=NULL;temp_service=temp_service->next){
+		if((temp_host=find_host(temp_service->host_name))){
+			if(temp_service->check_interval != 0) {
+				avg_interval_counter += temp_host->total_service_check_interval / temp_service->check_interval;
+				}
+			}
+		}
+	if(avg_interval_counter > 0) {
+		temp_host->avg_service_check_interval = temp_host->total_service_check_interval / avg_interval_counter;
+	}
+	
 	if(verify_config==TRUE){
 		printf("\n");
 		printf("Total Warnings: %d\n",warnings);
